'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _RGB = require('./RGB');

var _RGB2 = _interopRequireDefault(_RGB);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var relations = [['v', 't', 'p'], ['q', 'v', 'p'], ['p', 'v', 't'], ['p', 'q', 'v'], ['t', 'p', 'v'], ['v', 'p', 'q']];

var HSV = function () {
  function HSV() {
    var h = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
    var s = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
    var b = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;

    _classCallCheck(this, HSV);

    this._cursor = 0;
    this.setH(h);
    this.setS(s);
    this.setB(b);
  }

  _createClass(HSV, [{
    key: 'getH',
    value: function getH() {
      return this.h;
    }
  }, {
    key: 'setH',
    value: function setH(value) {
      this.h = Math.min(360, Math.max(0, value));
      this._cursor = Math.floor(this.h / 60) % 6;
    }
  }, {
    key: 'getS',
    value: function getS() {
      return this.s;
    }
  }, {
    key: 'setS',
    value: function setS(value) {
      this.s = Math.min(1, Math.max(0, value));
    }
  }, {
    key: 'getB',
    value: function getB() {
      return this.b;
    }
  }, {
    key: 'setB',
    value: function setB(value) {
      this.b = Math.min(1, Math.max(0, value));
    }
  }, {
    key: 'getV',
    value: function getV() {
      return this.getB();
    }
  }, {
    key: 'setV',
    value: function setV(value) {
      return this.setB(value);
    }
  }, {
    key: 'copy',
    value: function copy() {
      return new HSV(this.h, this.s, this.b);
    }
  }, {
    key: 'toString',
    value: function toString() {
      return 'hsb(' + this.h + ',' + this.s + ',' + this.b + ')';
    }
  }, {
    key: 'stripSB',
    value: function stripSB() {
      return new HSV(this.h, 1, 1);
    }
  }, {
    key: 'toRGB',
    value: function toRGB() {
      var pool = this._getPool();
      return new _RGB2.default(255 * pool[relations[this._cursor][0]], 255 * pool[relations[this._cursor][1]], 255 * pool[relations[this._cursor][2]]);
    }
  }, {
    key: '_getPool',
    value: function _getPool() {
      var f = this.h / 60 - this._cursor;
      return {
        f: f,
        p: this.b * (1 - this.s),
        q: this.b * (1 - f * this.s),
        t: this.b * (1 - (1 - f) * this.s),
        v: this.b
      };
    }
  }]);

  return HSV;
}();

exports.default = HSV;
//# sourceMappingURL=HSV.js.map