'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _HSV = require('./HSV');

var _HSV2 = _interopRequireDefault(_HSV);

var _Utils = require('./Utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var RGB = function () {
  function RGB() {
    var r = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
    var g = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
    var b = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;

    _classCallCheck(this, RGB);

    this.setR(r);
    this.setG(g);
    this.setB(b);
  }

  _createClass(RGB, [{
    key: 'getR',
    value: function getR() {
      return this.r;
    }
  }, {
    key: 'setR',
    value: function setR(value) {
      this.r = (0, _Utils.floor_clamp)(value, 0, 255);
    }
  }, {
    key: 'getG',
    value: function getG() {
      return this.g;
    }
  }, {
    key: 'setG',
    value: function setG(value) {
      this.g = (0, _Utils.floor_clamp)(value, 0, 255);
    }
  }, {
    key: 'getB',
    value: function getB() {
      return this.b;
    }
  }, {
    key: 'setB',
    value: function setB(value) {
      this.b = (0, _Utils.floor_clamp)(value, 0, 255);
    }
  }, {
    key: 'copy',
    value: function copy() {
      return new RGB(this.getR(), this.getG(), this.getB());
    }
  }, {
    key: 'toString',
    value: function toString() {
      return 'rgb(' + this.getR() + ',' + this.getG() + ',' + this.getB() + ')';
    }
  }, {
    key: 'toHex',
    value: function toHex() {
      return '#' + (0, _Utils.num_to_hex)(this.r) + (0, _Utils.num_to_hex)(this.g) + (0, _Utils.num_to_hex)(this.b);
    }
  }, {
    key: 'toHSV',
    value: function toHSV(hues) {
      var rgb = [this.getR(), this.getG(), this.getB()];
      rgb.sort(function sortNumber(a, b) {
        return a - b;
      });
      var max = rgb[2];
      var min = rgb[0];
      var ret = new _HSV2.default(0, max === 0 ? 0 : (max - min) / max, max / 255);
      var rgbR = this.getR();
      var rgbG = this.getG();
      var rgbB = this.getB();
      if (max === min) {
        //lost rgb
        ret.setH(hues);
      } else if (max === rgbR && rgbG >= rgbB) {
        ret.setH((rgbG - rgbB) * 60 / (max - min) + 0);
      } else if (max === rgbR && rgbG < rgbB) {
        ret.setH((rgbG - rgbB) * 60 / (max - min) + 360);
      } else if (max === rgbG) {
        ret.setH((rgbB - rgbR) * 60 / (max - min) + 120);
      } else if (max === rgbB) {
        ret.setH((rgbR - rgbG) * 60 / (max - min) + 240);
      }
      return ret;
    }
  }], [{
    key: 'fromHex',
    value: function fromHex(str) {
      if (!/^#[0-9a-fA-F]{6}$/.test(str)) {
        return null;
      }
      var r = parseInt(str.substring(1, 3), 16);
      var g = parseInt(str.substring(3, 5), 16);
      var b = parseInt(str.substring(5, 7), 16);
      return new RGB(r, g, b);
    }
  }]);

  return RGB;
}();

exports.default = RGB;

RGB.White = new RGB(255, 255, 255);
RGB.Black = new RGB(0, 0, 0);
//# sourceMappingURL=RGB.js.map