'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _RGB2 = require('./RGB');

var _RGB3 = _interopRequireDefault(_RGB2);

var _Utils = require('./Utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RGBA = function (_RGB) {
  _inherits(RGBA, _RGB);

  function RGBA() {
    var r = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
    var g = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
    var b = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
    var a = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 255;

    _classCallCheck(this, RGBA);

    var _this = _possibleConstructorReturn(this, (RGBA.__proto__ || Object.getPrototypeOf(RGBA)).call(this, r, g, b));

    _this.setA(a);
    return _this;
  }

  _createClass(RGBA, [{
    key: 'getA',
    value: function getA() {
      return this.a;
    }
  }, {
    key: 'setA',
    value: function setA(value) {
      this.a = (0, _Utils.floor_clamp)(value, 0, 255);
    }
  }, {
    key: 'setRGB',
    value: function setRGB(rgb) {
      this.setR(rgb.r);
      this.setG(rgb.g);
      this.setB(rgb.b);
    }
  }, {
    key: 'copy',
    value: function copy() {
      return new RGBA(this.r, this.g, this.b, this.a);
    }
  }, {
    key: 'toString',
    value: function toString() {
      return 'rgba(' + this.r + ',' + this.g + ',' + this.b + ',' + this.a + ')';
    }
  }, {
    key: 'toRGB',
    value: function toRGB() {
      return new RGBA(this.r, this.g, this.b);
    }
  }, {
    key: 'toHex',
    value: function toHex() {
      return _get(RGBA.prototype.__proto__ || Object.getPrototypeOf(RGBA.prototype), 'toHex', this).call(this) + (0, _Utils.num_to_hex)(this.a);
    }
  }], [{
    key: 'fromHex',
    value: function fromHex(str) {
      if (!/^#[0-9a-fA-F]{8}$/.test(str)) {
        return null;
      }
      var r = parseInt(str.substring(1, 3), 16);
      var g = parseInt(str.substring(3, 5), 16);
      var b = parseInt(str.substring(5, 7), 16);
      var a = parseInt(str.substring(7, 9), 16);
      return new RGBA(r, g, b, a);
    }
  }, {
    key: 'fromRGB',
    value: function fromRGB(rgb) {
      var a = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 255;

      return new RGBA(rgb.r, rgb.g, rgb.b, a);
    }
  }]);

  return RGBA;
}(_RGB3.default);

exports.default = RGBA;

RGBA.White = new RGBA(255, 255, 255, 255);
RGBA.WhiteT = new RGBA(255, 255, 255, 0);
RGBA.Black = new RGBA(0, 0, 0, 255);
RGBA.BlackT = new RGBA(0, 0, 0, 0);
//# sourceMappingURL=RGBA.js.map